'''
Created on Jul 5, 2019

@author: shuangyinli
'''
# coding: utf-8
 
from __future__ import print_function
import torch
from torch import nn
from torch import optim
from torch.autograd import Variable
import os
import re
import numpy as np
import sys
from model_gpu import TextRNN,TextCNN,TextLSTM,TextbiLSTM,TextGRU,TextRNNSeqToSeq,TextGRUSeqToSeq,TextLSTMSeqToSeq,TextbiLSTMSeqToSeq
import multiprocessing
from multiprocessing import Process, Manager
import time
from sklearn import svm
from sklearn.model_selection import KFold
from sklearn.metrics import precision_score, recall_score, f1_score

import os

#device = torch.device("cuda" if torch.cuda.is_available() else "cpu")
device = -1
dictionary =[]
n_hidden = -1
n_iters = 10000
lr = 0.01
iter_batch_size = 128

def remove(abstract):
    abstract = re.sub("[^A-Za-z]", ' ', abstract)
    ###remove a single word
    abstract=re.sub(' [a-zA-Z] ', ' ', abstract)
    abstract=re.sub('^[ ]*[a-zA-Z] ', ' ', abstract) 
    abstract=re.sub(' [a-zA-Z][ ]*$', ' ', abstract)
    abstract =  ' '.join(abstract.split())
    abstract = abstract.lower()
    return abstract

def readDictionary(dic_file):
    dictionary = []
    for line in dic_file:
        dictionary.append(line.rstrip().lstrip().split(":")[1])
    return dictionary

def split_average_data(thread_no, text_list):
    fn = len(text_list)//thread_no
    rn = len(text_list)%thread_no
    ar = [fn+1]*rn+ [fn]*(thread_no-rn)
    si = [i*(fn+1) if i<rn else (rn*(fn+1)+(i-rn)*fn) for i in range(thread_no)]
    corpusSplitlist = [text_list[si[i]:si[i]+ar[i]] for i in range(thread_no)]
    return corpusSplitlist

def multi_process_prepareData(text_file):
    
    text_list = [line for line in text_file]
    
    workers = []
    workers_no = num_threads
    corpusSplitlist = split_average_data(workers_no,text_list)
    manager = Manager()
    
    ManagerReturn_corpusSplitlist = []
    for dataSplit in corpusSplitlist:
        return_dataSplit = manager.list()
        worker = Process(target=getData, args=(dataSplit, return_dataSplit))
        
        worker.start()
        workers.append(worker)
        ManagerReturn_corpusSplitlist.append(return_dataSplit)
        
        pass
    for w in workers:
        w.join()
    
    all_text = {}
    all_category = []
    for split_ in ManagerReturn_corpusSplitlist:
        for sen in split_:
            # []
            all_category+= sen[0]
            #{}
            temp = sen[1]
            for key, value in temp.items():
                if key not in all_text:
                    all_text.setdefault(key)
                    all_text[key] = value
                else:
                    all_text[key] += value
            
    all_category = list(set(all_category))
    if len(all_category) != len(all_text):
        print("data precess is wrong")
        exit()
    
    return all_category, all_text

def getData(data_file, managerDoclist):
    category_lines = {}
    all_categories = []
    text_num = 0
    for line in data_file:
        label = line.rstrip().lstrip().split("##")[0]
        text = line.rstrip().lstrip().split("##")[1]
        text_list = remove(text).split()
        word_list = []
        for word in text_list:
            if word in dictionary:
                word_list.append(word)
        if len(word_list) ==0:
            continue
        text_num += 1
        if text_num % 10000 == 0:
            print("read " + str(text_num) +" docs")
        if label not in all_categories:
            all_categories.append(label)
            category_lines.setdefault(label)
            lineslist = []
            lineslist.append(word_list)
            category_lines[label] = lineslist
        else:
            category_lines[label].append(word_list)
    
    managerDoclist.append((all_categories, category_lines))

def multiprocesses_process_file(all_categories, category_lines, max_length=100):
    
    text_list = []
    for key, value in category_lines.items():
        text_list.append((key,value))
    
    workers = []
    workers_no = num_threads
    corpusSplitlist = split_average_data(workers_no,text_list)
    manager = Manager()
    
    ManagerReturn_corpusSplitlist = []
    for dataSplit in corpusSplitlist:
        return_dataSplit = manager.list()
        worker = Process(target=multi_process_file, args=(all_categories, dataSplit, max_length, return_dataSplit))
        
        worker.start()
        workers.append(worker)
        ManagerReturn_corpusSplitlist.append(return_dataSplit)
        
        pass
    for w in workers:
        w.join()
    
    data_id = []
    label_id = []
    for split_ in ManagerReturn_corpusSplitlist:
        for sen in split_:
            data_id += sen[0]
            label_id += sen[1]
            
    x_pad = np.array(data_id, dtype = int)
    y_pad = to_categorical(label_id, num_classes=len(all_categories))
    
    return x_pad, y_pad
 
def multi_process_file(all_categories, dataSplit, max_length, return_dataSplit):
    data_id, label_id = [], []
    category_lines = {}
    for item in dataSplit:
        if item[0] not in category_lines:
            category_lines.setdefault(item[0])
            category_lines[item[0]] = item[1]
        else:
            category_lines[item[0]] += item[1]
    
    for key, values in category_lines.items():
        for value in values:
            label_id.append(all_categories.index(key))
            sigle_line = []
            for word in value:
                if word in dictionary:
                    sigle_line.append(dictionary.index(word))
                pass
            data_id.append(sigle_line)
        pass
    pass

    for i in range(len(data_id)):
        if len(data_id[i]) > max_length:
            data_id[i] = data_id[i][:max_length]
        else:
            data_id[i] = data_id[i] + [0 for j in range(max_length - len(data_id[i]))]
            
    return return_dataSplit.append((data_id, label_id))
    
 
def process_file(all_categories, category_lines, dictionary, max_length=100):
    data_id, label_id = [], []
    for key, values in category_lines.items():
        for value in values:
            label_id.append(all_categories.index(key))
            sigle_line = []
            for word in value:
                if word in dictionary:
                    sigle_line.append(dictionary.index(word))
                pass
            data_id.append(sigle_line)
        pass
    pass

    for i in range(len(data_id)):
        if len(data_id[i]) > max_length:
            data_id[i] = data_id[i][:max_length]
        else:
            data_id[i] = data_id[i] + [0 for j in range(max_length - len(data_id[i]))]
            
    x_pad = np.array(data_id, dtype = int)
    y_pad = to_categorical(label_id, num_classes=len(all_categories))
    return x_pad, y_pad
 
def to_categorical(y, num_classes):
    """ 1-hot encodes a tensor """
    return np.eye(num_classes, dtype='uint8')[y]

def batch_iter(x, y, batch_size=64):
    """生成批次数据"""
    data_len = len(x)
    num_batch = int((data_len - 1) / batch_size) + 1
 
    indices = np.random.permutation(np.arange(data_len))
    x_shuffle = x[indices]
    y_shuffle = y[indices]
 
    for i in range(num_batch):
        start_id = i * batch_size
        end_id = min((i + 1) * batch_size, data_len)
        yield x_shuffle[start_id:end_id], y_shuffle[start_id:end_id]
        
def train(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = process_file(train_all_categories, train_category_lines, dictionary, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = process_file(test_all_categories, test_category_lines, dictionary, max_length=100)
    len_dictionary = len(dictionary)
    len_category = len(train_all_categories)
    
    embedding_matrix = torch.zeros((len_dictionary, len_dictionary)).cuda(device)
    for i in range(len_dictionary):
        embedding_matrix[i][i] = 1
    
    print("begin training")
    #使用LSTM或者CNN
    model = TextRNN(len_dictionary, n_hidden, len_category,len_dictionary,len_dictionary,embedding_matrix)

    #选择损失函数
    Loss = nn.MultiLabelSoftMarginLoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr=0.001)
    best_val_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,100)
        loss_sum = 0
        for x_batch, y_batch in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            y = Variable(torch.Tensor(y_batch)).cuda(device)
            out = model(x)
            loss = Loss(out,y)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
            loss_sum += loss
        print("Training on epoch" + str(epoch) +", and loss is " + str(loss))
        #对模型进行验证
        if (epoch+1)%200 == 0:
            batch_val = batch_iter(x_val, y_val, len(x_val))
            for x_batch, y_batch in batch_val:
                x = Variable(torch.LongTensor(x_batch))
                y = Variable(torch.Tensor(y_batch))
                out = model(x)
                accracy = np.mean((torch.argmax(out, 1) == torch.argmax(y, 1)).numpy())
                if accracy > best_val_acc:
                    #torch.save(model.state_dict(),'model_params.pkl')
                    best_val_acc = accracy
                print(accracy)

def train_TextRNNSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)

    print("begin training")
    #使用LSTM或者CNN
    model = TextRNNSeqToSeq(100, n_hidden, len_dictionary)
    model = model.cuda(device)

    #选择损失函数
    Loss = nn.MSELoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_val_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        loss_sum = 0
        for x_batch, _ in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            x_embedding, encodding, decodding = model(x)
            # (batch, seq_len, hidden_size) for encodding
            loss = Loss(x_embedding, decodding)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
            loss_sum += loss
        if loss_sum < 0.0005:
            print("Training on epoch" + str(epoch) +", and loss is " + str(loss_sum))
            break
    
    x = Variable(torch.LongTensor(x_val[:1000]))
    model = model.cpu()
    x_embedding, encodding, decodding = model(x)
    # (batch, seq_len, hidden_size) for encodding
    # Here we use the last hidden outputs as the features for each document, as encodding[:,-1,:]
    
    # test on classfication task
    feature_test = encodding[:,-1,:]
    #one-hot to list
    labels_test = torch.LongTensor(y_val[:1000]).argmax(dim=1, keepdim=True)
    SVCclassifier(feature_test.detach().numpy(), labels_test.detach().numpy())

def train_TextLSTMSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)

    print("begin training")
    #使用LSTM或者CNN
    model = TextLSTMSeqToSeq(100, n_hidden, len_dictionary)
    model = model.cuda(device)

    #选择损失函数
    Loss = nn.MSELoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_val_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        loss_sum = 0
        for x_batch, _ in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            x_embedding, encodding, decodding = model(x)
            # (batch, seq_len, hidden_size) for encodding
            loss = Loss(x_embedding, decodding)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
            loss_sum += loss
        if loss_sum < 0.0005:
            print("Training on epoch" + str(epoch) +", and loss is " + str(loss_sum))
            break
    
    x = Variable(torch.LongTensor(x_val))
    model = model.cpu()
    x_embedding, encodding, decodding = model(x)
    # (batch, seq_len, hidden_size) for encodding
    # Here we use the last hidden outputs as the features for each document, as encodding[:,-1,:]
    
    # test on classfication task
    feature_test = encodding[:,-1,:]
    #one-hot to list
    labels_test = torch.LongTensor(y_val).argmax(dim=1, keepdim=True)
    SVCclassifier(feature_test.detach().numpy(), labels_test.detach().numpy())
    
def train_TextbiLSTMSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)

    print("begin training")
    #使用LSTM或者CNN
    model = TextbiLSTMSeqToSeq(100, n_hidden, len_dictionary)
    model = model.cuda(device)

    #选择损失函数
    Loss = nn.MSELoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_val_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        loss_sum = 0
        for x_batch, _ in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            x_embedding, encodding, decodding = model(x)
            # (batch, seq_len, hidden_size) for encodding
            loss = Loss(x_embedding, decodding)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
            loss_sum += loss
        if loss_sum < 0.0005:
            print("Training on epoch" + str(epoch) +", and loss is " + str(loss_sum))
            break
    
    x = Variable(torch.LongTensor(x_val))
    model = model.cpu()
    x_embedding, encodding, decodding = model(x)
    # (batch, seq_len, hidden_size) for encodding
    # Here we use the last hidden outputs as the features for each document, as encodding[:,-1,:]
    
    # test on classfication task
    feature_test = encodding[:,-1,:]
    #one-hot to list
    labels_test = torch.LongTensor(y_val).argmax(dim=1, keepdim=True)
    SVCclassifier(feature_test.detach().numpy(), labels_test.detach().numpy())
    
def train_TextGRUSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)

    print("begin training")
    #使用LSTM或者CNN
    model = TextGRUSeqToSeq(100, n_hidden, len_dictionary)
    model = model.cuda(device)

    #选择损失函数
    Loss = nn.MSELoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_val_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        loss_sum = 0
        for x_batch, _ in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            x_embedding, encodding, decodding = model(x)
            # (batch, seq_len, hidden_size) for encodding
            loss = Loss(x_embedding, decodding)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
            loss_sum += loss
        if loss_sum < 0.0005:
            print("Training on epoch" + str(epoch) +", and loss is " + str(loss_sum))
            break
    
    x = Variable(torch.LongTensor(x_val))
    model = model.cpu()
    x_embedding, encodding, decodding = model(x)
    # (batch, seq_len, hidden_size) for encodding
    # Here we use the last hidden outputs as the features for each document, as encodding[:,-1,:]
    
    # test on classfication task
    feature_test = encodding[:,-1,:]
    #one-hot to list
    labels_test = torch.LongTensor(y_val).argmax(dim=1, keepdim=True)
    SVCclassifier(feature_test.detach().numpy(), labels_test.detach().numpy())

def SVCclassifier(feature_test, labels_test):
    feature_test = np.array(feature_test)
    labels_test = np.array(labels_test)
    np.random.seed(10)
    shuffle_indices = np.random.permutation(np.arange(feature_test.shape[0]))
    x_shuffled = feature_test[shuffle_indices]
    y_shuffled = labels_test[shuffle_indices]
    
    kf = KFold(n_splits=5)
    scoreNum = []
    f1Num = []
    for train_index, test_index in kf.split(x_shuffled):
        X_train, X_test = x_shuffled[train_index], x_shuffled[test_index]
        y_train, y_test = y_shuffled[train_index], y_shuffled[test_index]

        #train a classifier
        clf = svm.SVC(C=2.0, cache_size=200, class_weight=None, coef0=0.0, degree=5, kernel='rbf',gamma='scale', max_iter=-1, probability=True, random_state=None, shrinking=True, tol=0.1, verbose=False)
        clf.fit(X_train, y_train.ravel())
        y_pred = clf.predict(X_test) 
        f1value = f1_score(y_test, y_pred,average="micro")

        acc = clf.score(X_test, y_test)
         
        scoreNum.append(acc)
        f1Num.append(f1value)
        
    print(" Accurracy  is: "  + str(np.sum(scoreNum) / 5.0) + " std : " + str(np.std(scoreNum)))
    print("F1  is: "+str(np.sum(f1Num) / 5.0) + " std: " + str(np.std(f1Num)))
    
    
def train_rnn(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)
    len_category = len(train_all_categories)
    
    print("begin training rnn")
    model = TextRNN(100, n_hidden, len_category, len_dictionary)
    model = model.cuda(device)
    
    #选择损失函数
    #Loss = nn.MultiLabelSoftMarginLoss().cuda(device)
    # Loss = nn.BCELoss()
    Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    
    best_acc = 0
    
    for epoch in range(n_iters):
        loss_sum = 0
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        for x_batch, y_batch in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            y = Variable(torch.Tensor(y_batch)).cuda(device)
            out = model(x)
            loss = Loss(out,y)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
            loss_sum += loss
        print("Training on epoch" + str(epoch) +", and loss is " + str(loss))
        #对模型进行验证
        if (epoch+1)%100 == 0:
            xval = Variable(torch.LongTensor(x_val[:1000])).cuda(device)
            yval = Variable(torch.Tensor(y_val[:1000])).cuda(device)
            out = model(xval)
            a = torch.argmax(out, 1)
            b =  torch.argmax(yval, 1)
            tem = 0
            for i in range(len(a)):
                if a[i] == b[i]:
                    tem +=1
            if best_acc < tem/len(a):
                best_acc = tem/len(a)
            print("accuracy on epoch" + str(epoch) +" is " + str(best_acc))
            
#     print("begin testing rnn")        
#     x = Variable(torch.LongTensor(x_val[:1000]))
#     y = Variable(torch.Tensor(y_val[:1000]))
#     model = model.cpu()
#     out = model(x)
#     accuracy = np.mean((torch.argmax(out, 1) == torch.argmax(y, 1)).numpy())
#     print("The final accuracy on testset is with "+str(epoch) + ": "+str(accuracy))
            
def train_lstm(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)
    len_category = len(train_all_categories)
    
    print("begin training")
    model = TextLSTM(100, n_hidden, len_category,len_dictionary)
    model = model.cuda(device)
    #选择损失函数
    #Loss = nn.MultiLabelSoftMarginLoss().cuda(device)
    # Loss = nn.BCELoss()
    Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_acc = 0
    
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        for x_batch, y_batch in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            y = Variable(torch.Tensor(y_batch)).cuda(device)
            out = model(x)
            loss = Loss(out,y)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
        if (epoch+1)%100 == 0:
            xval = Variable(torch.LongTensor(x_val[:1000])).cuda(device)
            yval = Variable(torch.Tensor(y_val[:1000])).cuda(device)
            out = model(xval)
            a = torch.argmax(out, 1)
            b =  torch.argmax(yval, 1)
            tem = 0
            for i in range(len(a)):
                if a[i] == b[i]:
                    tem +=1
            if best_acc < tem/len(a):
                best_acc = tem/len(a)
            print("accuracy on epoch" + str(epoch) +" is " + str(best_acc))
    
def train_bilstm(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)
    len_category = len(train_all_categories)
    
    print("begin training")

    model = TextbiLSTM(100, n_hidden, len_category,len_dictionary)
    model = model.cuda(device)
    Loss = nn.MultiLabelSoftMarginLoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        for x_batch, y_batch in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            y = Variable(torch.Tensor(y_batch)).cuda(device)
            out = model(x)
            loss = Loss(out,y)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()

        if (epoch+1)%100 == 0:
            xval = Variable(torch.LongTensor(x_val[:1000])).cuda(device)
            yval = Variable(torch.Tensor(y_val[:1000])).cuda(device)
            out = model(xval)
            a = torch.argmax(out, 1)
            b =  torch.argmax(yval, 1)
            tem = 0
            for i in range(len(a)):
                if a[i] == b[i]:
                    tem +=1
            if best_acc < tem/len(a):
                best_acc = tem/len(a)
            print("accuracy on epoch" + str(epoch) +" is " + str(best_acc))
        
    
def train_gru(train_all_categories, train_category_lines, test_all_categories,test_category_lines):
    print("begin process_file")
    x_train, y_train = multiprocesses_process_file(train_all_categories, train_category_lines, max_length=100)#获取训练数据每个字的id和对应标签的oe-hot形式
    x_val, y_val = multiprocesses_process_file(test_all_categories, test_category_lines, max_length=100)
    len_dictionary = len(dictionary)
    len_category = len(train_all_categories)
    
    print("begin training")
    model = TextGRU(100, n_hidden, len_category,len_dictionary)
    model = model.cuda(device)
    #选择损失函数
    Loss = nn.MultiLabelSoftMarginLoss().cuda(device)
    # Loss = nn.BCELoss()
    # Loss = nn.MSELoss()
    optimizer = optim.Adam(model.parameters(),lr)
    best_acc = 0
    for epoch in range(n_iters):
        batch_train = batch_iter(x_train, y_train,iter_batch_size)
        
        for x_batch, y_batch in batch_train:
            x = Variable(torch.LongTensor(x_batch)).cuda(device)
            y = Variable(torch.Tensor(y_batch)).cuda(device)
            out = model(x)
            loss = Loss(out,y)
            optimizer.zero_grad()
            loss.backward()
            optimizer.step()
        if (epoch+1)%100 == 0:
            xval = Variable(torch.LongTensor(x_val[:1000])).cuda(device)
            yval = Variable(torch.Tensor(y_val[:1000])).cuda(device)
            out = model(xval)
            a = torch.argmax(out, 1)
            b =  torch.argmax(yval, 1)
            tem = 0
            for i in range(len(a)):
                if a[i] == b[i]:
                    tem +=1
            if best_acc < tem/len(a):
                best_acc = tem/len(a)
            print("accuracy on epoch" + str(epoch) +" is " + str(best_acc))
    
    
if __name__ == '__main__':
    if (len(sys.argv) != 8):
        print("usage: python NNmethods.py <model type> <train_file> <test_file> <dic> <hidden layer size> <num_threads> <gpu> \n")
        sys.exit(1)
    
    modeltype = sys.argv[1]
    train_file = open(sys.argv[2],"r",encoding='utf-8')
    test_file = open(sys.argv[3],"r",encoding='utf-8')
    dic_file = open(sys.argv[4],"r",encoding='utf-8')
    n_hidden = int(sys.argv[5])
    num_threads = int(sys.argv[6])
    GPU_ID = str(sys.argv[7])
    
    #os.environ["CUDA_VISIBLE_DEVICES"] = GPU_ID
    
    if torch.cuda.is_available():
        device = "cuda:"+ GPU_ID
    else:
        device = "cpu"
    
    print("The model name is : "+ str(modeltype))
    print("The program will be processed on " + str(device))
    print("The n_hidden is set to " + str(n_hidden))
    dictionary = readDictionary(dic_file)
    print("begin get Data with " +str(num_threads) + " Threads")
    cur_round_begin_time = time.time()
    
    print("prepare data...")
    train_all_categories, train_category_lines = multi_process_prepareData(train_file)
    test_all_categories, test_category_lines = multi_process_prepareData(test_file)
    
    cur_round_cost_time = time.time() - cur_round_begin_time
    print("Getting Data is done, cost_time= "+str(cur_round_cost_time))
    
    if modeltype == "rnn":
        train_rnn(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "lstm":
        train_lstm(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "bilstm":
        train_bilstm(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "gru":
        train_gru(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "rnnseqtoseq":
        train_TextRNNSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "lstmseqtoseq":
        train_TextLSTMSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "bilstmseqtoseq":
        train_TextbiLSTMSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
    elif modeltype == "gruseqtoseq":
        train_TextGRUSeqToSeq(train_all_categories, train_category_lines, test_all_categories,test_category_lines)
        
        